
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>关于Java中进程和线程的详解 / 憋错料</title>

    <meta name="description" content="关于Java中进程和线程的详解 一.进程:是程序的一次动态执行,它对应着从代码加载,执行至执行完毕的一个完整的过程,是一个动态的实体,它有自己的生命 周期.它因创建而产生,因调度而运行,因等待资源或事件而被处于等待状态,因完成任务而被撤消.反映了一个程序在 一定的数据 集上运行的全部动态过程.通过进程控制块(PCB)唯一的标识某个进程.同时进程占据着相应的资源(例如包 括cpu的使用 ,轮转时间以及一些其它设备的权限).是系统进行资源分配和调度的一个独立单位. 程序和进程之间的主要区别在于: 状态         是否具有资源">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">关于Java中进程和线程的详解</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>一.进程:</strong>是程序的一次动态执行，它对应着从代码加载，执行至执行完毕的一个完整的过程，是一个动态的实体，它有自己的生命</p>
<p>周期。它因创建而产生，因调度而运行，因等待资源或事件而被处于等待状态，因完成任务而被撤消。反映了一个程序在</p>
<p>一定的数据&nbsp;集上运行的全部动态过程。通过进程控制块(PCB)唯一的标识某个进程。同时进程占据着相应的资源（例如包</p>
<p>括cpu的使用&nbsp;，轮转时间以及一些其它设备的权限）。是系统进行资源分配和调度的一个独立单位。</p>
<p>程序和进程之间的主要区别在于：</p>
<p>状态&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 是否具有资源&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 是否有唯一标识&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 是否具有并发性</p>
<p>进程&nbsp;&nbsp;&nbsp;&nbsp; 动态&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 有&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 有&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 有</p>
<p>程序&nbsp;&nbsp;&nbsp;&nbsp; 静态&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 无&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 无&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;无</p>
<p>进程的基本状态:</p>
<p>1、就绪（Ready）状态</p>
<p>当进程已分配到除CPU以外的所有必要资源后，只要在获得CPU，便可立即执行，进程这时的状态就称为就绪状态。在一个系统中处于就绪状态的进程可能有多个，通常将他们排成一个队列，称为就绪队列。</p>
<p>2、执行状态</p>
<p>进程已获得CPU，其程序正在执行。在单处理机系统中，只有一个进程处于执行状态；再多处理机系统中，则有多个进程处于执行状态。</p>
<p>3、阻塞状态</p>
<p>正在执行的进程由于发生某事件而暂时无法继续执行时，便放弃处理机而处于暂停状态，亦即程序的执行受到阻塞，把这种暂停状态称为阻塞状态，有时也称为等待状态或封锁状态。</p>
<p>三种进程之间的转换图：</p>
<p><strong>&nbsp; &nbsp;线程:&nbsp;</strong>可以理解为进程的多条执行线索，每条线索又对应着各自独立的生命周期。线程是进程的一个实体,是CPU调度和分派的</p>
<p>基本单位,它是比进程更小的能独立运行的基本单位。一个线程可以创建和撤销另一个线程，同一个进程中的多个线程之</p>
<p>间可以并发执行。</p>
<p>这里在详细讲解一下Java中的进程和线程的概念。</p>
<p>Java中的线程要经历4个过程</p>
<p>1）创建</p>
<p>创建一个Java线程常见的有两种方式:</p>
<p>继承Thread类和实现Runnable接口这两种方式。</p>
<p>2）执行</p>
<p>线程创建后仅仅占有了内存资源，在JVM管理的线程中还没有该线程，该线程必须调用start方法通知JVM，这样JVM</p>
<p>就会知道又有一个新的线程排队等候了。如果当前线程轮到了CPU的使用权限的话，当前线程就会继续执行。</p>
<p>3）中断</p>
<p>a.JVM将CPU的使用权限从当前线程切换到其它线程，使本线程让出CPU的使用权限而处于中断状态。</p>
<p>b.线程在执行过程中调用了sleep方法，使当前线程处于休眠状态。</p>
<p>c.线程在执行的过程中调用wait方法</p>
<p>d.线程在使用cpu资源期间，执行了某个操作而进如阻塞状态。</p>
<p>4）死亡</p>
<p>死亡的线程不在具有执行能力。线程死亡的原因有二：</p>
<p>a.线程正常运行结束而引起的死亡，即run方法执行完毕。</p>
<p>b.线程被提前强制终止。</p>
<h2><strong>二：线程的创建及使用</strong></h2>
<p><strong>java使用Thread类代表线程，所有的线程对象都必须是Thread或者其子类的实例，每个线程的作用是完成一定任务，实际上是就是执行一段程序流（一段顺序执行的代码）</strong></p>
<h3><strong>方案一：继承Thread类创建线程类</strong></h3>
<p>步骤：1.定义Thread类的子类 并重写该类的Run方法，该run方法的方法体就代表了该线程需要完成的任务</p>
<p>2.创建Thread类的实例，即创建了线程对象</p>
<p>3.调用线程的start方法来启动线程</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkwNDA4Ni8yMDE3MDEvOTA0MDg2LTIwMTcwMTA3MTg1MzAyNTgxLTgxMTEwNDIzNC5wbmc=.jpg"></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkwNDA4Ni8yMDE3MDEvOTA0MDg2LTIwMTcwMTA3MTg1MzEyOTQxLTE5MDgyMzIyMjUucG5n.jpg"></p>
<p>结论：使用继承子Thread类的子类来创建线程类时，多个线程无法共享线程类的实例变量(比如上面的i)</p>
<h3><strong>方案二：实现Runnable接口</strong></h3>
<p>1：定义Runnable接口的实现类，并重写它的Run方法，run方法同样是该线程的执行体！</p>
<p>2：创建Runnable实现类的实例，并将此实例作为Thread的target创建一个Thread对象，该Thread对象才是真正的线程对象！</p>
<p>3：调用start方法启动该线程</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkwNDA4Ni8yMDE3MDEvOTA0MDg2LTIwMTcwMTA3MTg1MzMyMjA2LTQ3OTcxODg1My5wbmc=.jpg"></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkwNDA4Ni8yMDE3MDEvOTA0MDg2LTIwMTcwMTA3MTg1MzQxNDA5LTExNDMxNjM1NzgucG5n.jpg"></p>
<p>结论：采用Ruunable接口的方式创建多个线程可以共享线程类的实例变量，这是因为在这种方式下，程序创建的Runnable对象只是线程的target，而多个线程可以共享一个target，所以多个线程可以共享一个实例变量</p>
<p>通过Runnable实现多线程其实就是将run包装成线程的执行体，但是目前java无法将任意方法包装成线程执行体</p>
<h3><strong>方案三：</strong>使用callable和future创建线程</h3>
<p><strong>从Java5开始，Java提供 Callable接口,Callable接口提供了一个call（）方法可以作为线程执行体，看起来和Runnable很像，但call（）方法更强大——call（）方法可以有返回值、call（）方法可以抛出异常</strong></p>
<p><strong>&nbsp;</strong></p>
<p>Java5提供了Future接口来代表Callable接口的call（）方法的返回值，并为Future接口提供了一个FutureTask实现类，该实现类实现类Future接口，也实现了Runnable接口——可以作为Thread的target。</p>
<p>实现步骤：</p>
<p>1：创建Callable接口的实现类，并实现call方法，该call方法会成为线程执行体，且call方法具有返回值，在创建callable接口的实现类！</p>
<p>2：使用FutrueTask类来包装Callable对象，该FutrueTask封装类Callable的call方法的返回值</p>
<p>3：使用FutrueTask对象作为Thread的target创建并启动新线程！</p>
<p>4：使用FutrueTask的get方法获取执行结束后的返回值</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkwNDA4Ni8yMDE3MDEvOTA0MDg2LTIwMTcwMTA3MTg1NDA1NTY2LTE4MDY2ODc0NzMucG5n.jpg"></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkwNDA4Ni8yMDE3MDEvOTA0MDg2LTIwMTcwMTA3MTg1NDEyNzg0LTk3MjEyMzc1MS5wbmc=.jpg"></p>
<p>结论：采取Runnable、Callable的优势在于——线程类只是实现了Runnable或Callable接口，还可以继承其它类；在这种方法下，多个线程可以共享一个target对象，因此非常适合多个相同线程处理同一份资源的情况，从而将CPU、代码和数据分开，形参清晰的模型，体现了面对对象的编程思想。劣势在于编程复杂度略高。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 02:10:55 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/strong/" title="strong">strong</a>, <a href="https://www.biecuoliao.com/tag/%e8%bd%ac%e6%8d%a2/" title="转换">转换</a>, <a href="https://www.biecuoliao.com/tag/ges/" title="ges">ges</a>, <a href="https://www.biecuoliao.com/tag/cpu/" title="cpu">cpu</a>, <a href="https://www.biecuoliao.com/tag/call/" title="call">call</a>, <a href="https://www.biecuoliao.com/tag/%e5%88%9b%e5%bb%ba%e7%ba%bf%e7%a8%8b/" title="创建线程">创建线程</a>, <a href="https://www.biecuoliao.com/tag/%e6%94%be%e5%bc%83/" title="放弃">放弃</a>, <a href="https://www.biecuoliao.com/tag/%e8%bf%9b%e7%a8%8b%e5%92%8c%e7%ba%bf%e7%a8%8b/" title="进程和线程">进程和线程</a>, <a href="https://www.biecuoliao.com/tag/%e8%bf%9b%e7%a8%8b%e6%8e%a7%e5%88%b6/" title="进程控制">进程控制</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>关于Java中进程和线程的详解的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3O2gBr0.html" rel="bookmark">Java性能分析之线程栈详解（下）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java性能分析之线程栈详解(下) 转载自:微信公众号&quot;测试那点事儿&quot; 结合jstack结果对线程状态详解 上篇文章详细介绍了线程栈的作用.状态.任何查看理解,本篇文章结合jstack工具来查看线程状态,并列出重点关注目标.Jstack是常用的排查工具,它能输出在某一个时间,Java进程中所有线程的状态,很多时候这些状态信息能给我们的排查工作带来有用的线索. Jstack的输出中,Java线程状态主要是以下几种: 1.BLOCKED 线程在等待monitor锁(synchronized			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0axANEM.html" rel="bookmark">Java中static作用及用法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.1概述: static是静态修饰符,什么叫静态修饰符呢?大家都知道,在程序中任何变量或者代码都是在编译时由系统自动分配内存来存储的,而所谓静态就是指在编译后所分配的内存会一直存在,直到程序退出内存才会释放这个空间,也就是只要程序在运行,那么这块内存就会一直存在.这样做有什么意义呢?在Java程序里面,所有的东西都是对象,而对象的抽象就是类,对于一个类而言,如果要使用他的成员,那么普通情况下必须先实例化对象后,通过对象的引用才能够访问这些成员,但是用static修饰的成员可以通过类名加&quot;.&q			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/495Q7X4.html" rel="bookmark">Java中的多线程技术全面详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文主要从整体上介绍Java中的多线程技术,对于一些重要的基础概念会进行相对详细的介绍,若有叙述不清晰或是不正确的地方,希望大家指出,谢谢大家:) 为什么使用多线程 并发与并行 我们知道,在单核机器上,&quot;多进程&quot;并不是真正的多个进程在同时执行,而是通过CPU时间分片,操作系统快速在进程间切换而模拟出来的多进程.我们通常把这种情况成为并发,也就是多个进程的运行行为是&quot;一并发生&quot;的,但不是同时执行的,因为CPU核数的限制(PC和通用寄存器只有一套,严格来说在同一时刻只能			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qk7RpM.html" rel="bookmark">关于Java中的程序，进程和线程的详解&period;&period;&period;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				程序:一段静态的代码,一组指令的有序集合,它本身没有任何运行的含义,它只是一个静态的实体,是应用软件执行的蓝本. 进程:是程序的一次动态执行,它对应着从代码加载,执行至执行完毕的一个完整的过程,是一个动态的实体,它有自己的生命 周期.它因创建而产生,因调度而运行,因等待资源或事件而被处于等待状态,因完成任务而被撤消.反映了一个程序在 一定的数据 集上运行的全部动态过程.通过进程控制块(PCB)唯一的标识某个进程.同时进程占据着相应的资源(例如包 括cpu的使用 ,轮转时间以及一些其它设备的权限)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YG17r4.html" rel="bookmark">java中进程与线程--三种实现方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一:进程与线程 概述:几乎任何的操作系统都支持运行多个任务,通常一个任务就是一个程序,而一个程序就是一个进程.当一个进程运行时,内部可能包括多个顺序执行流,每个顺序执行流就是一个线程. 进程:进程是指处于运行过程中的程序,并且具有一定的独立功能.进程是系统进行资源分配和调度的一个单位.当程序进入内存运行时,即为进程. 进程的三个特点: 1:独立性:进程是系统中独立存在的实体,它可以独立拥有资源,每一个进程都有自己独立的地址空间,没有进程本身的运行,用户进程不可以直接访问其他进程的地址空间. 2:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41onmJ0.html" rel="bookmark">Java中的IO流系统详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java 流在处理上分为字符流和字节流.字符流处理的单元为 2 个字节的 Unicode 字符,分别操作字符.字符数组或字符串,而字节流处理单元为 1 个字节,操作字节和字节数组. Java 内用 Unicode 编码存储字符,字符流处理类负责将外部的其他编码的字符流和 java 内 Unicode 字符流之间的转换.而类 InputStreamReader 和 OutputStreamWriter 处理字符流和字节流的转换.字符流(一次可以处理一个缓冲区)一次操作比字节流(一次一个字节)效率高			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLJBrd3.html" rel="bookmark">Java中的异常和处理详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文出处:代码钢琴家 简介 程序运行时,发生的不被期望的事件,它阻止了程序按照程序员的预期正常执行,这就是异常.异常发生时,是任程序自生自灭,立刻退出终止,还是输出错误给用户?或者用C语言风格:用函数返回值作为执行状态?. Java提供了更加优秀的解决办法:异常处理机制. 异常处理机制能让程序在异常发生时,按照代码的预先设定的异常处理逻辑,针对性地处理异常,让程序尽最大可能恢复正常并继续执行,且保持代码的清晰. Java中的异常可以是函数中的语句执行时引发的,也可以是程序员通过throw 语句手			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyqAKpM.html" rel="bookmark">java中synchronized的用法与详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java语言的关键字,当它用来修饰一个方法或者一个代码块的时候,能够保证在同一时刻最多只有一个线程执行该段代码. 一.当两个并发线程访问同一个对象object中的这个synchronized(this)同步代码块时,一个时间内只能有一个线程得到执行.另一个线程必须等待当前线程执行完这个代码块以后才能执行该代码块. 二.然而,当一个线程访问object的一个synchronized(this)同步代码块时,另一个线程仍然可以访问该object中的非synchronized(this)同步代码块.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mg7ypKM.html" rel="bookmark">Java 中的异常和处理详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文出处: 代码钢琴家 简介 程序运行时,发生的不被期望的事件,它阻止了程序按照程序员的预期正常执行,这就是异常.异常发生时,是任程序自生自灭,立刻退出终止,还是输出错误给用户?或者用C语言风格:用函数返回值作为执行状态?. Java提供了更加优秀的解决办法:异常处理机制. 异常处理机制能让程序在异常发生时,按照代码的预先设定的异常处理逻辑,针对性地处理异常,让程序尽最大可能恢复正常并继续执行,且保持代码的清晰. Java中的异常可以是函数中的语句执行时引发的,也可以是程序员通过throw 语句			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n3ZZqL3.html" rel="bookmark" class="title">Springboot 热部署中存在冲突的问题</a>
					<div>
						SpringBoot热部署有2中: 1.使用 Spring Loaded 2.使用 spring-boot-devtools 具体怎么用.自己百度! 在使用第一种时候,整合SpringBoot和通用M ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JDJLY0.html" rel="bookmark" class="title">Android 使用Sharedpreference共享参数</a>
					<div>
						import java.util.HashMap; import java.util.Map; import android.content.Context; import android.conte ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OmvXoM.html" rel="bookmark" class="title">关于展开详情与收起</a>
					<div>
						&lt;imgng-show=&quot;colRows.HasCode&quot;ng-click=&quot;colRows.HasCode=!colRows.HasCode;&quot;src= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NAEeo3.html" rel="bookmark" class="title">RDLC报表使用记录</a>
					<div>
						1.报表项目搭建: 配置好后,单击Web服务URL:http://lg-20151517ryre/ReportServer 如果电脑系统打开的时候没有设置密码的话,此时打开有可能会出现需要登录名和密码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02DYmB4.html" rel="bookmark" class="title">Atitit&period; 解决80端口  System 占用pid 4&comma;&comma;找到拉个程序或者服务占用http 80服务</a>
					<div>
						Atitit. 解决80端口  System 占用pid 4,,找到拉个程序或者服务占用http服务 这个是http.sys系统服务占用了... net stop http ,三,没法儿终止 1. 寻 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MX7BoV4.html" rel="bookmark" class="title">Python中的代码注释</a>
					<div>
						为什么要使用注释? 1. 方便自己查看写过的代码  2. 互联网人才流动大,为了项目能更好维护,需要适当写注释. Python的注释符 1. 单行注释 # 1 #!/usr/bin/env pytho ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aADnk0.html" rel="bookmark" class="title">JAVA代码实现嵌套层级列表，POI导出嵌套层级列表</a>
					<div>
						要实现POI导出EXCEL形如 --A1(LV1) ----B1(LV2) ----B2(LV2) ------C1(LV3) ------C2(LV3) ----B3(LV2) --A1(LV1)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aAzVA0.html" rel="bookmark" class="title">识别Json字符串并分隔成Map集合</a>
					<div>
						识别Json字符串并分隔成Map集合 前言: 最近又看了点Java的知识,于是想着把CYQ.Data V5迁移到Java版本. 过程发现坑很多,理论上看大部分很相似,实践上代码写起来发现大部分都要重新 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49r6LXM.html" rel="bookmark" class="title">007-指针</a>
					<div>
						C语言 指针简单使用如下: int *p;//定义 int a = 10; p = &amp;a;//赋值 int * b = &amp;a;//定义并赋值 定义格式:类型 *指针变量名: 注意事项: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rbE773.html" rel="bookmark" class="title">如何玩转微信支付功能的原理和开发（转）</a>
					<div>
						打开微信,各种营销信息霸占了我的眼球,以“微信支付+微信小店”的模式挑战阿里“支付宝+淘宝天猫”的模式开启了新纪元,腾讯此举是在革淘宝的命吗?有人说,微信对阿里最大的挑战,是把连接能力下发给了企业/用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBbwajM.html" rel="bookmark" class="title">马程序员学习笔记&mdash;&mdash;红黑树解析四</a>
					<div>
						---------------------- ASP.Net+Unity开发..Net培训.期待与您交流! ---------------------- 本篇是将上面三篇的理论知识转化成代码,java ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AWewv0.html" rel="bookmark" class="title">【&period;net深呼吸】动态类型（高级篇）</a>
					<div>
						前面老周给大家介绍了动态类型使用的娱乐级别用法,其实,在很多情景下,娱乐级别的用法已经满足需求了. 如果,你想自己来控制动态类型的行为和数据的存取,那么,就可以考虑用今天所说的高大上技术了.比如,你希 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXZYxb3.html" rel="bookmark" class="title">hdu--2191--终于可以说出dp水题这句话了-&period;-</a>
					<div>
						这题是 上一题的 recommend 过来的 很水.. 虽然是多重背包 但是 因为数据太小了 完全可以不用二进制拆分去做 我两者都去写了下 ...都是0ms.. 1 #include &lt;iost ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YLXeWM.html" rel="bookmark" class="title">centos6&period;5下安装mysql，远程访问</a>
					<div>
						安装参考:http://www.cnblogs.com/xiaoluo501395377/archive/2013/04/07/3003278.html,很详细. 安装成功后,得做相应配置才能从别的机 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bLzOL4.html" rel="bookmark" class="title">SQLServer查找哪些存储过程是已经加密的</a>
					<div>
						--判断存储过程是否加密 select * from sys.objects SP left join sys.sql_modules AS smsp ON smsp.object_id = sp.o ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OQ7AGM.html" rel="bookmark" class="title">&lbrack;LeetCode&rsqb; NO&period; 27 Remove Element</a>
					<div>
						[题目] Given an array and a value, remove all instances of that value in place and return the new leng ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41ywaP4.html" rel="bookmark" class="title">【网络编程】&mdash;&mdash;connect函数遇见EINTR的处理</a>
					<div>
						最近在公司项目中突然报错如下 “connect: Interrupted system call”, 经过查找代码发现是在创建 socket 中执行了 connect 函数失败导致.上网查阅资料发现这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyNAdm0.html" rel="bookmark" class="title">iOS中使用RegexKitLite来试用正则表达式 使用ARC 20个错误解决办法</a>
					<div>
						You can also disable the ARC for the RegexKitLite only by adding a flag: select the project -&gt; YO ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyNgOV0.html" rel="bookmark" class="title">字符串处理 2015百度之星资格赛 1002 列变位法解密</a>
					<div>
						题目传送门 1 /* 2 字符串处理:要求解码,然而二维数组开不下,可以直接输出 3 只要在余数的地方判断一下就行了,vector的效率不高 4 另外:感觉麻烦的地方应该纸上写写就清楚了 5 */ 6 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pDzlo4.html" rel="bookmark" class="title">Winform 串口通讯之读卡器</a>
					<div>
						老板给我的第一个硬件就是一个读卡器, 说让我做一下试试,于是从网上查了查就写了出来,相当的简单. 但是后来还有一个地磅的串口通讯,我整整搞了一天. 在窗体类的构造函数中写入 Form.CheckFor ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
